Difference between revisions of "Draft BezCurve/it"

From FreeCAD Documentation
Jump to: navigation, search
 
(4 intermediate revisions by the same user not shown)
Line 7: Line 7:
 
==Descrizione==  
 
==Descrizione==  
  
Lo strumento Curva di Bézier crea una [http://en.wikipedia.org/wiki/Bezier_curve Curva di Bezier], o un suo tratto, da più punti. Assume [[Draft Linestyle/it|lo spessore e il colore]] precedentemente impostati nella Barra dei comandi del [[Draft Tray/it|Vassoio di Draft]].
+
Lo strumento Curva di Bézier crea una [http://en.wikipedia.org/wiki/Bezier_curve Curva di Bezier], o un suo tratto, da più punti. Assume [[Draft Linestyle/it|lo spessore e il colore]] precedentemente impostati nella [[Draft Tray/it|barra di Draft]].
  
 
Lo strumento Curva di Bezier utilizza {{Emphasis|i punti di controllo}} per definire la direzione della curva; invece lo strumento [[Draft BSpline/it|B-spline]] specifica i punti esatti attraverso i quali deve passare la curva. Per creare curve circolari o ellittiche esatte, usare [[Draft Arc/it|Arco]] e [[Draft Ellipse/it|Ellisse]].
 
Lo strumento Curva di Bezier utilizza {{Emphasis|i punti di controllo}} per definire la direzione della curva; invece lo strumento [[Draft BSpline/it|B-spline]] specifica i punti esatti attraverso i quali deve passare la curva. Per creare curve circolari o ellittiche esatte, usare [[Draft Arc/it|Arco]] e [[Draft Ellipse/it|Ellisse]].
Line 23: Line 23:
 
L'oggetto viene creato come una unica curva di Bezier di grado uguale a {{incode|number_of_points - 1}} (al numero di punti - 1). Dopo la creazione può essere commutato in tratti di curva di Bezier di determinato grado modificando le sue [[Property/it|proprietà]].
 
L'oggetto viene creato come una unica curva di Bezier di grado uguale a {{incode|number_of_points - 1}} (al numero di punti - 1). Dopo la creazione può essere commutato in tratti di curva di Bezier di determinato grado modificando le sue [[Property/it|proprietà]].
  
<div class="mw-translate-fuzzy">
 
 
La Curva di Bézier può essere modificata facendo doppio clic sull'elemento nella vista ad albero o premendo il pulsante {{Button|[[Image:Draft Edit.svg|16px]] [[Draft Edit/it|Modifica]]}}. Quindi si possono spostare i punti in una nuova posizione o fare clic su {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint/it|aggiungi punto]]}} o {{Button|[[Image:Draft_DelPoint.svg|16px]] [[Draft_DelPoint/it|rimuovi punto]]}} e quindi fare clic sulla curva per aggiungere o rimuovere punti. Si può anche cambiare il tipo di vincolo di ogni punto.
 
La Curva di Bézier può essere modificata facendo doppio clic sull'elemento nella vista ad albero o premendo il pulsante {{Button|[[Image:Draft Edit.svg|16px]] [[Draft Edit/it|Modifica]]}}. Quindi si possono spostare i punti in una nuova posizione o fare clic su {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint/it|aggiungi punto]]}} o {{Button|[[Image:Draft_DelPoint.svg|16px]] [[Draft_DelPoint/it|rimuovi punto]]}} e quindi fare clic sulla curva per aggiungere o rimuovere punti. Si può anche cambiare il tipo di vincolo di ogni punto.
</div>
 
  
 
===Vincolare i nodi===
 
===Vincolare i nodi===
Line 65: Line 63:
 
* {{PropertyData|Continuity}}: (sola lettura) quando la curva è chiusa, indica la continuità della curva {{incode|[0]}}, o {{incode|[0,0]}}. Altrimenti è  {{incode|[]}}.
 
* {{PropertyData|Continuity}}: (sola lettura) quando la curva è chiusa, indica la continuità della curva {{incode|[0]}}, o {{incode|[0,0]}}. Altrimenti è  {{incode|[]}}.
  
<div class="mw-translate-fuzzy">
 
 
=== Vista ===
 
=== Vista ===
 
* {{PropertyView|Arrow Size}}: specifica la dimensione del simbolo visualizzato alla fine della curva.
 
* {{PropertyView|Arrow Size}}: specifica la dimensione del simbolo visualizzato alla fine della curva.
Line 72: Line 69:
 
* {{PropertyView|Pattern}}: specifica un tipo di [[Draft Pattern/it|Campitura]] con cui riempire la faccia della curva chiusa. Questa proprietà funziona solo se {{PropertyData|Make Face}} è {{TRUE}}, e se {{PropertyView|Display Mode}} è "Flat Lines".
 
* {{PropertyView|Pattern}}: specifica un tipo di [[Draft Pattern/it|Campitura]] con cui riempire la faccia della curva chiusa. Questa proprietà funziona solo se {{PropertyData|Make Face}} è {{TRUE}}, e se {{PropertyView|Display Mode}} è "Flat Lines".
 
* {{PropertyView|Pattern Size}}: specifica la dimensione della [[Draft Pattern/it|Campitura]].
 
* {{PropertyView|Pattern Size}}: specifica la dimensione della [[Draft Pattern/it|Campitura]].
</div>
 
  
<div class="mw-translate-fuzzy">
 
 
== Script ==
 
== Script ==
 
{{Emphasis|Vedere anche:}} [[Draft API/it|API Draft]] e [[FreeCAD Scripting Basics/it|Nozioni di base sugli script di FreeCAD]].
 
{{Emphasis|Vedere anche:}} [[Draft API/it|API Draft]] e [[FreeCAD Scripting Basics/it|Nozioni di base sugli script di FreeCAD]].
</div>
 
  
<div class="mw-translate-fuzzy">
 
 
Lo strumento Curva di Bézier può essere usato nelle [[macros/it|macro]] e dalla console [[Python/it|Python]] utilizzando la seguente funzione:
 
Lo strumento Curva di Bézier può essere usato nelle [[macros/it|macro]] e dalla console [[Python/it|Python]] utilizzando la seguente funzione:
</div>
 
 
{{Code|code=
 
{{Code|code=
 
BezCurve = makeBezCurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
 
BezCurve = makeBezCurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)

Latest revision as of 19:19, 6 October 2019

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe
Arrow-left.svg Draft Facebinder.svg Lega facce Pagina precedente:
Pagina successiva: Curva di Bézier cubica Draft CubicBezCurve.svg Arrow-right.svg

Draft BezCurve.svg Curva di Bezier

Posizione nel menu
Draft → Strumenti Beziér → Curva di Bézier
Ambiente
Draft, Arch
Avvio veloce
B Z
Introdotto nella versione
0.14
Vedere anche
Polilinea, B-spline


Descrizione

Lo strumento Curva di Bézier crea una Curva di Bezier, o un suo tratto, da più punti. Assume lo spessore e il colore precedentemente impostati nella barra di Draft.

Lo strumento Curva di Bezier utilizza i punti di controllo per definire la direzione della curva; invece lo strumento B-spline specifica i punti esatti attraverso i quali deve passare la curva. Per creare curve circolari o ellittiche esatte, usare Arco e Ellisse.

Draft BezCurve Example.png

Curva di Bézier definita da più punti di controllo


Utilizzo

  1. Premere il pulsante Draft BezCurve.png Curva di Bézier, o premere i tasti B e poi Z.
  2. Selezionare un primo punto nella vista 3D, oppure digitare le sue coordinate e poi premere il pulsante Draft AddPoint.svg aggiungi punto.
  3. Selezionare un nuovo punto nella vista 3D, oppure digitare le sue coordinate e poi premere il pulsante Draft AddPoint.svg aggiungi punto.
  4. Premere il tasto Esc o il pulsante Chiudi, o fare doppio clic sull'ultimo punto per terminare l'edizione.

L'oggetto viene creato come una unica curva di Bezier di grado uguale a number_of_points - 1 (al numero di punti - 1). Dopo la creazione può essere commutato in tratti di curva di Bezier di determinato grado modificando le sue proprietà.

La Curva di Bézier può essere modificata facendo doppio clic sull'elemento nella vista ad albero o premendo il pulsante Draft Edit.svg Modifica. Quindi si possono spostare i punti in una nuova posizione o fare clic su Draft AddPoint.svg aggiungi punto o Draft DelPoint.svg rimuovi punto e quindi fare clic sulla curva per aggiungere o rimuovere punti. Si può anche cambiare il tipo di vincolo di ogni punto.

Vincolare i nodi

I punti finali del segmento possono essere vincolati in modo tale che i punti di controllo adiacenti siano tangenti o simmetrici rispetto ai segmenti nel punto finale. Iniziare a modificare la curva, poi scegliere uno degli strumenti e quindi scegliere un punto. Fare nuovamente clic sullo strumento per disattivarlo, in modo da poter spostare il punto.

  • Draft BezSharpNode.svg sharp (crea nodo Bezier spigoloso) rimuove i vincoli sui punti in modo che la curva possa avere spigoli vivi.
  • Draft BezTanNode.svg tangent (crea nodo Bezier tangente) forza i punti di controllo adiacenti a essere tangenti.
  • Draft BezSymNode.svg symmetric (crea nodo Bezier simmetrico) forza i punti di controllo adiacenti a essere tangenti ed equidistanti.

Limitazioni

  • Le proprietà Punti non compaiono ancora nell'elenco delle proprietà.
  • OpenCascade, e quindi FreeCAD, non supporta le curve di Bézier di grado superiore a 25. Questo non dovrebbe essere un problema nella pratica, poiché la maggior parte degli utenti usa tipicamente le curve di Bézier da 3 a 5 gradi.

Opzioni

  • Premere il tasto A o il pulsante Draft FinishLine.png Termina per terminare la curva, lasciandola aperta.
  • Premere il tasto O o il pulsante Draft CloseLine.png Chiudi per chiudere la curva, cioè per aggiungere un segmento dall'ultimo punto al primo per formare una faccia. Per formare una faccia sono necessari almeno quattro punti, e una curva di grado tre.
  • Premere il tasto W o il pulsante Draft Wipe.svg Pulisci per rimuovere i segmenti della curva già posizionati, ma continuare a creare la curva dall'ultimo punto.
  • Premere il tasto U o il pulsante Draft SelectPlane.svg Imposta il piano per posizionare il piano di lavoro corrente nell'orientamento dell'ultimo punto.
  • Premere il tasto X, o Y o Z dopo un punto per vincolare il successivo punto sul dato asse.
  • Per inserire le coordinate manualmente, basta inserire i valori e poi premere Invio per ciascun componente X, Y e Z.
  • Premere il tasto R oppure fare clic sulla casella di controllo per attivare la modalità "relativo". Se la modalità relativo è attiva, le coordinate del punto successivo sono relative all'ultimo; in caso contrario, sono assolute, prese dall'origine (0,0,0).
  • Premere il tasto T oppure fare clic sulla casella di controllo per attivare la modalità "continua". Se la modalità continua è attiva, lo strumento Curva di Bézier si riavvia dopo aver terminato la Curva di Bézier in costruzione, e consente di disegnare una nuova Curva di Bézier senza premere nuovamente il pulsante dello strumento.
  • Premere il tasto L oppure fare clic sulla casella di controllo per attivare la modalità riempito. Se la modalità di riempimento è attiva una Curva di Bézier chiusa crea una faccia piena (DATAMake Face True); in caso contrario, la Curva di Bézier chiusa non crea una faccia (DATAMake Face False).
Nota: la curva non deve essere riempita se si autointerseca, in quanto non crea una faccia corretta. Se la curva è piena ma non è visibile nessuna forma, impostare manualmente DATAMake Face su False per vedere la spline.
  • Tenere premuto Ctrl mentre si disegna per forzare l'aggancio del proprio punto alla posizione di aggancio più vicina, indipendentemente dalla distanza.
  • Tenere premuto Maiusc mentre si disegna per vincolare il punto successivo in orizzontale o in verticale rispetto all'ultimo.
  • Premere Ctrl+Z o il pulsante Draft UndoLine.png Undo per annullare l'ultimo punto.
  • Premere il tasto Esc o il pulsante Chiudi per interrompere il comando corrente; le curve già posizionate rimamgono.

Proprietà

Dati

  • DATADegree: specifica il grado della curva di Bezier o dei singoli segmenti.
  • DATAClosed: specifica se la curva è chiusa o no. Se la curva è inizialmente aperta, questo valore è False; impostandolo su True viene disegnato un segmento per chiudere la curva. Se la curva è inizialmente chiusa, questo valore è True; impostandolo su False si rimuove l'ultimo segmento e si apre la curva.
  • DATAMake Face: specifica se la spline crea o no una faccia. Se è True crea una faccia, altrimenti solo il perimetro è considerato parte dell'oggetto. Questa proprietà funziona solo se DATAClosed è True.
Nota: non impostare DATAMake Face su True se la curva si autointerseca, poiché non crea una faccia corretta.
  • DATAContinuity: (sola lettura) quando la curva è chiusa, indica la continuità della curva [0], o [0,0]. Altrimenti è [].

Vista

  • VIEWArrow Size: specifica la dimensione del simbolo visualizzato alla fine della curva.
  • VIEWArrow Type: specifica il tipo di simbolo visualizzato alla fine della curva, che può essere dot, circle, arrow, o tick.
  • VIEWEnd Arrow: specifica se mostrare un simbolo nell'ultimo punto della curva, in modo che possa essere usata come una linea di annotazione.
  • VIEWPattern: specifica un tipo di Campitura con cui riempire la faccia della curva chiusa. Questa proprietà funziona solo se DATAMake Face è True, e se VIEWDisplay Mode è "Flat Lines".
  • VIEWPattern Size: specifica la dimensione della Campitura.

Script

Vedere anche: API Draft e Nozioni di base sugli script di FreeCAD.

Lo strumento Curva di Bézier può essere usato nelle macro e dalla console Python utilizzando la seguente funzione:

BezCurve = makeBezCurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
BezCurve = makeBezCurve(Part.Wire, closed=False, placement=None, face=None, support=None, degree=None)
  • Crea un oggetto BezCurve dalla data lista di punti pointslist.
    • Ogni punto della lista è definito dal suo FreeCAD.Vector, con unità in millimetri.
    • In alternativa, l'input può essere una Part.Wire, da cui vengono estratti i punti.
  • Se closed è True, o se il primo e l'ultimo punto coincidono, la curva è chiusa.
  • Se viene dato un placement esso viene usato; altrimenti la forma viene creata nell'origine.
  • Se face è True e la curva è chiusa, diventa una faccia e appare riempita.

Esempio:

import FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(2000, 0, 0)
p4 = FreeCAD.Vector(1500, -2000, 0)

BezCurve1 = Draft.makeBezCurve([p1, p2, p3, p4], closed=True)
BezCurve2 = Draft.makeBezCurve([p4, 1.3*p2, p1, 4.1*p3], closed=True)
BezCurve3 = Draft.makeBezCurve([1.7*p3, 1.5*p4, 2.1*p2, p1], closed=True)
Arrow-left.svg Draft Facebinder.svg Lega facce Pagina precedente:
Pagina successiva: Curva di Bézier cubica Draft CubicBezCurve.svg Arrow-right.svg